'****************************************************************************
'
' PBMAIL Paket : PBLOG.BAS (Common Logfile-Routines)
' Version      : 0.14g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
' Last Updates : see directly in the sources
'
' based on UKAW/UKAD technology
'
'****************************************************************************

DECLARE FUNCTION LogHandle(BYVAL LogFile AS STRING) AS LONG
DECLARE FUNCTION LogIntro() AS STRING
DECLARE FUNCTION LogDate AS STRING
DECLARE SUB Get_AppPath()
DECLARE SUB LogWrite(TEXT AS STRING, LogThread AS LONG, LogState AS INTEGER)
DECLARE FUNCTION PBVersion AS STRING

%LogState_Normal      = 0
%LogState_FatalError  = 1
%LogState_OtherError  = 2
%LogState_CostInfo    = 3
%LogState_Filenames   = 4
%LogState_Routing     = 5
%LogState_BriefMsg    = 6
%LogState_TrivialMsg  = 7
%LogState_TransStat   = 8
%LogState_SessionInfo = 9
%LogState_RasDialResp = 10
%LogState_Debug       = 255

'-------------------------------------------------------------------------------------------
' UKAW Logfile ffnen und diverse Sicherheitsabfragen durchfhren/vorbereiten
'-------------------------------------------------------------------------------------------
SUB LogOpen()

        LOCAL sLogAppDeb AS STRING        '

        ON ERROR RESUME NEXT

        hLogFile   = -1                   ' PBMAIL Logfile
        Local_IP   = ""

        sLogAppDeb = REMOVE$(sLogApp$, " ")

        ' Debug-Mode aktiviert
        IF LEN(DIR$(sLogAppDeb$ + ".DEB")) > 0 THEN
            hLogDebug% = %TRUE
        END IF
        hLogFile = LogHandle("PBMAIL.LOG")       ' PBMAIL eigenes LogFile ffnen
        IF hLogFile > 0 THEN
            PRINT #hLogFile, LogIntro
        END IF

END SUB

'-------------------------------------------------------------------------------------------
' Handle fr Logfile holen
'-------------------------------------------------------------------------------------------
FUNCTION LogHandle(BYVAL LogFile AS STRING) AS LONG

        LOCAL hLog           AS LONG      '
        ON ERROR GOTO LogHandleError

        hLog = FREEFILE
        OPEN LogFile$ FOR APPEND AS #hLog
        FUNCTION = hLog
        EXIT FUNCTION

LogHandleError:
        FUNCTION = -1
END FUNCTION

'-------------------------------------------------------------------------------------------
' gemeinsames Intro fr Logfile
'-------------------------------------------------------------------------------------------
FUNCTION LogIntro AS STRING

        LOCAL Temp       AS STRING        '

        Temp$ = "----------  " + LogDate$ + ", PBMAIL " + Version$ + " - (compilation by Thomas Gohel / 2003)"
        IF hLogDebug% = %True THEN
            Temp$ = Temp$ + CrLf$ + "  "+ TIME$ + "  " + sLogApp$ + "  : " + _
                    "Debug-Mode activated"
        END IF
        FUNCTION = Temp$

END FUNCTION

'-------------------------------------------------------------------------------------------
' Schreiben der Logfiles
'-------------------------------------------------------------------------------------------
SUB LogWrite(TEXT AS STRING, LogThread AS LONG, LogState AS INTEGER)

        DIM sThread    AS STRING
        DIM sLogState  AS STRING
        DIM hLogWrite  AS INTEGER
        DIM LogInfo    AS STRING

        IF LogThread& >= 0 THEN
            sThread = "#" + FORMAT$(LogThread&,"#")
        ELSE
            sThread = "  "
        END IF

        SELECT CASE LogState%
            CASE   0: sLogState = "  ": hLogWrite% = %True
            CASE   1: sLogState = "! ": hLogWrite% = %True
            CASE   2: sLogState = "? ": hLogWrite% = %True
            CASE   3: sLogState = "$ ": hLogWrite% = %True
            CASE   4: sLogState = "* ": hLogWrite% = %False
            CASE   5: sLogState = ": ": hLogWrite% = %True
            CASE   6: sLogState = "+ ": hLogWrite% = %True
            CASE   7: sLogState = "- ": hLogWrite% = %True
            CASE   8: sLogState = "% ": hLogWrite% = %True
            CASE   9: sLogState = "~ ": hLogWrite% = %True
            CASE  10: sLogState = "= ": hLogWrite% = %True
            CASE 255: sLogState = "  ": hLogWrite% = %False
        END SELECT
        IF hLogDebug% = %TRUE THEN
             hLogWrite% = %TRUE
        END IF

        IF hLogWrite% = %TRUE THEN
            LogInfo = sLogState + TIME$ + "  " + sLogApp$ + sThread + ": " + Text$
            IF hLogFile > 0 THEN
                PRINT #hLogFile, LogInfo
            END IF
        END IF
END SUB

'-------------------------------------------------------------------------------------------
' Logfile(s) schliessen
'-------------------------------------------------------------------------------------------
SUB LogClose

        IF hLogFile > 0 THEN
            CLOSE #hLogFile          ' PBMAIL Logfile schliessen
        END IF
END SUB

'-------------------------------------------------------------------------------------------
' Datums/Zeiteintrge fr Logfile generieren
'-------------------------------------------------------------------------------------------
FUNCTION LogDate AS STRING

        LOCAL LogFormat    AS STRING
        LOCAL LogDayOfWeek AS STRING
        LOCAL LogDay       AS STRING
        LOCAL LogYear      AS STRING
        LOCAL LogXPMonth   AS STRING
        LOCAL LogFDMonth   AS STRING
        LOCAL SystemDatum  AS SYSTEMTIME

        GetLocalTime SystemDatum

        SELECT CASE SystemDatum.wDayOfWeek
            CASE 0: LogDayOfWeek$ = "Sun"
            CASE 1: LogDayOfWeek$ = "Mon"
            CASE 2: LogDayOfWeek$ = "Tue"
            CASE 3: LogDayOfWeek$ = "Wed"
            CASE 4: LogDayOfWeek$ = "Thu"
            CASE 5: LogDayOfWeek$ = "Fri"
            CASE 6: LogDayOfWeek$ = "Sat"
        END SELECT

        LogDay$ = FORMAT$(SystemDatum.wDay,"##")
        REPLACE " " WITH "0" IN LogDay$

        LogXPMonth$ = FORMAT$(SystemDatum.wMonth,"##")
        REPLACE " " WITH "0" IN LogXPMonth$

        LogFormat$ = UCASE$(ENVIRON$("PBLOG"))

        SELECT CASE SystemDatum.wMonth
            CASE  1: LogFDMonth$ = "Jan"
            CASE  2: LogFDMonth$ = "Feb"
            CASE  3: LogFDMonth$ = "Mar"
            CASE  4: LogFDMonth$ = "Apr"
            CASE  5: LogFDMonth$ = "May"
            CASE  6: LogFDMonth$ = "Jun"
            CASE  7: LogFDMonth$ = "Jul"
            CASE  8: LogFDMonth$ = "Aug"
            CASE  9: LogFDMonth$ = "Sep"
            CASE 10: LogFDMonth$ = "Oct"
            CASE 11: LogFDMonth$ = "Nov"
            CASE 12: LogFDMonth$ = "Dec"
        END SELECT

        LogYear$ = STR$(SystemDatum.wYear)

        SELECT CASE LogFormat$
            CASE "XP"
                FUNCTION = LogDay$ + "." + LogXPMonth$ + "." + _
                           RIGHT$(LogYear$,4)
            CASE "FD"
                FUNCTION = LogDayOfWeek$ + " "  + LogDay$ + " " + _
                           LogFDMonth$ + " " + RIGHT$(LogYear$,2)
            CASE ELSE
                FUNCTION = LogDayOfWeek$ + " "  + LogDay$ + " " + _
                           LogFDMonth$ + " " + RIGHT$(LogYear$,2)
        END SELECT

END FUNCTION

'-------------------------------------------------------------------------------------------
' Applikationsverzeichnis finden
'-------------------------------------------------------------------------------------------
SUB Get_AppPath()

        LOCAL CommandLine  AS ASCIIZ PTR
        LOCAL AppExe       AS STRING
        LOCAL i            AS INTEGER
        LOCAL Temp         AS STRING

        CommandLine = GetCommandLine()
        Temp = PARSE$(@CommandLine, " ", 1)
        Temp$ = REMOVE$(Temp$, CHR$(34))
        FOR i% = LEN(Temp$) TO 1 STEP -1
            IF RIGHT$(MID$(Temp$, 1, i%), 1) = "\" THEN EXIT FOR
        NEXT i%
        AppPath$ = MID$(Temp$, 1, i%)
        AppExe$  = MID$(Temp$, i% + 1)

END SUB

'-------------------------------------------------------------------------------------------
' PowerBASIC-String aufbereiten
'-------------------------------------------------------------------------------------------
FUNCTION PBVersion() AS STRING

        LOCAL PBVer   AS STRING

        PBVer$ = TRIM$(HEX$(%PB_REVISION))
        PBVer$ = "PowerBASIC/CC v" + LEFT$(PBVer$, 1) + "." + RIGHT$(PBVer$, 2)
        ' + " Build " + TRIM$(STR$(%pb_revletter))
        FUNCTION = PBVer$

END FUNCTION
