'****************************************************************************
'
' PBNEWS Paket : RAS.INC (RasAPI32 Include File)
' Version      : 0.15g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
' Last Updates : see directly in the sources
'
' all original sources by Karl-Heinz Weiss
' based on UKAW/UKAD technology
'
'****************************************************************************

%UNLEN = 256
%PWLEN = 256
%DNLEN = 15
%RAS_MaxEntryName      = 256
%RAS_MaxDeviceName     = 128
%RAS_MaxDeviceType     = 16
%RAS_MaxPhoneNumber    = 128
%RAS_MaxCallbackNumber = 128
%RASCS_Connected       = &h2000

TYPE RasConnStatus
    dwSize       AS DWORD
    rasconnstate AS DWORD
    dwError      AS DWORD
    szDeviceType AS ASCIIZ * %RAS_MaxDeviceType + 1
    szDeviceName AS ASCIIZ * %RAS_MaxDeviceName + 1
    Dummy        AS ASCIIZ * 2
END TYPE

TYPE RasConn
    dwSize       AS DWORD
    hrasconn     AS DWORD
    szEntryName  AS ASCIIZ * %RAS_MaxEntryName + 1
    szDeviceType AS ASCIIZ * %RAS_MaxDeviceType + 1
    szDeviceName AS ASCIIZ * %RAS_MaxDeviceName + 1
    Dummy        AS ASCIIZ * 1
END TYPE

TYPE RasDialParams
    dwSize           AS DWORD
    szEntryName      AS ASCIIZ * %RAS_MaxEntryName + 1
    szPhoneNumber    AS ASCIIZ * %RAS_MaxPhoneNumber + 1
    szCallbackNumber AS ASCIIZ * %RAS_MaxCallbackNumber + 1
    szUserName       AS ASCIIZ * %UNLEN + 1
    szPassword       AS ASCIIZ * %PWLEN + 1
    szDomain         AS ASCIIZ * %DNLEN + 1
    Dummy            AS ASCIIZ * 3
END TYPE

TYPE RasEntryName
    dwSize           AS DWORD
    szEntryName      AS ASCIIZ * %RAS_MaxEntryName + 1
    Dummy            AS ASCIIZ * 3
END TYPE

DECLARE FUNCTION RasDial LIB "rasapi32.dll" ALIAS "RasDialA" (BYVAL lpRasDialExtensions AS LONG, BYVAL lpszPhonebook AS LONG, lpRasDialParams AS RasDialParams, BYVAL dwNotifierType AS LONG, BYVAL lpvNotifier AS LONG, lphras AS LONG) AS LONG
DECLARE FUNCTION RasHangup LIB "rasapi32.dll" ALIAS "RasHangUpA" (BYVAL hrasconn AS DWORD) AS LONG
DECLARE FUNCTION RasEnumEntries LIB "rasapi32.dll" ALIAS "RasEnumEntriesA" (BYVAL lpszReserved AS DWORD, BYVAL lpszPhonebook AS DWORD, BYVAL lpszRasEntryNameA AS DWORD, LPDWORD AS LONG, lpcEntries AS LONG) AS LONG
DECLARE FUNCTION RasEnumConnections LIB "rasapi32.dll" ALIAS "RasEnumConnectionsA" (BYVAL lpRasConnA AS DWORD, lpDWORD AS LONG, LPDWORD AS LONG) AS LONG
DECLARE FUNCTION RasGetEntryDialParams LIB "rasapi32.dll" ALIAS "RasGetEntryDialParamsA" (BYVAL LPSTR AS DWORD, lpRasDialParams AS RasDialParams, LPBOOL AS LONG) AS LONG
DECLARE FUNCTION RasGetErrorString LIB "rasapi32.dll" ALIAS "RasGetErrorStringA" (BYVAL hRasError AS LONG, hRasErrorBuff AS ASCIIZ, BYVAL hRasErrorBufLen AS DWORD) AS DWORD
DECLARE FUNCTION RasGetConnectStatus LIB "rasapi32.dll" ALIAS "RasGetConnectStatusA" (BYVAL hRasCon AS DWORD, lpRasConnStatus AS RasConnStatus) AS DWORD

DECLARE FUNCTION SelectISP AS STRING
DECLARE FUNCTION UpdateISP AS STRING

GLOBAL rdParam             AS RasdialParams

FUNCTION GetRasError(RasError AS LONG) AS STRING

        DIM RasErrorBuff    AS ASCIIZ * 512  ' Buffer mit Win-Zeichensatz
        DIM RasErrorText    AS ASCIIZ * 512  ' Buffer mit DOS-Zeichensatz
        DIM RasErrorBuffLen AS DWORD
        DIM i               AS LONG

        RasErrorBuffLen??? = 512             ' Sollte immer 512 sein, da
                                             ' unter NT auch Unicode bis zu
                                             ' 512 Bytes/Char zurckgegeben
                                             ' werden knnen!
        i& = RasGetErrorString(RasError&, RasErrorBuff$, RasErrorBuffLen???)
        CharToOEM RasErrorBuff, RasErrorText
        FUNCTION = RasErrorText

END FUNCTION

FUNCTION SelectISP AS STRING

        DIM RasEntries(255)    AS RASENTRYNAME
        DIM RasEntriesSize     AS LONG
        DIM RasEntriesMax      AS LONG
        DIM RasConnectionName  AS STRING
        DIM fBool              AS LONG
        DIM i                  AS INTEGER
        DIM Result             AS LONG
        DIM A                  AS STRING

        fBool   = 0
        RasEntries(0).dwSize = 264
        RasEntriesSize = 256 * RasEntries(0).dwSize
        Result& = RasEnumEntries(0, 0, VARPTR(RasEntries(0)), RasEntriesSize, RasEntriesMax)

        RasEntriesMax = RasEntriesMax - 1   ' Anzahl der vorhandenen DF-Netzwerkverbindungen

        COMBOBOX RESET hRasDial, %IDC_RASDIAL_COMBOBOX

        FOR i% = 0 TO RasEntriesMax
            RasConnectionName = RasEntries(i%).szEntryName
            COMBOBOX ADD hRasDial, %IDC_RASDIAL_COMBOBOX, RasConnectionName
        NEXT i%

        COMBOBOX SELECT hRasDial, %IDC_RASDIAL_COMBOBOX, 1

        UpdateISP

END FUNCTION

FUNCTION UpdateISP AS STRING

        DIM RasConnectionName  AS STRING
        DIM fBool              AS LONG
        DIM Result             AS LONG

        ' Username/Password/Phonenumber eintragen
        COMBOBOX GET TEXT hRasDial, %IDC_RASDIAL_COMBOBOX TO RasConnectionName
        'rdParam.dwSize = SIZEOF(rdParam)
        rdParam.dwSize = LEN(rdParam)
        rdParam.szEntryName = RasConnectionName
        Result = RasGetEntryDialParams(0, rdparam, fBool)
        IF Result = 0 THEN
             CONTROL SET TEXT hRasDial, %IDC_RASDIAL_USER, rdParam.szUserName
             CONTROL SET TEXT hRasDial, %IDC_RASDIAL_PWD, rdParam.szPassWord
             ' Hier noch einen Umweg ber "RasGetEntryProperties" einbauen, da Nummer nicht zurckgegeben wird
             ' CONTROL SET TEXT hRasDial, %IDC_RASDIAL_PHONE, rdParam.szPhoneNumber
        END IF

END FUNCTION
