'****************************************************************************
'
' UKAW Paket   : CS32.INC (CrossSecretary Plugin for Win32)
' Version      : 2.99g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Copyright    : Christian von Busse
'                Thomas Gohel
' Last Files at: www.gohel.de
' Last Updates : see directly in the sources
'
'****************************************************************************

TYPE CS_Data
        ReturnFlag   AS LONG
        Optionen     AS LONG
        BrettPos     AS LONG
        KritPos      AS LONG
        LastPos      AS LONG
        FilterDatei  AS LONG
END TYPE

DECLARE FUNCTION CS_Init (BYVAL FilterFile AS STRING, FilterCfg() AS STRING) AS LONG
'
' CheckThread liest folgende Headerzeilen aus: MID, BEZ
DECLARE FUNCTION CS_CheckThread(No AS LONG, MsgId AS STRING, References AS STRING) AS LONG
DECLARE FUNCTION CS_Count(S AS STRING, Zeichen AS STRING) AS LONG
DECLARE FUNCTION CS_DateToJulian (Datum AS STRING) AS LONG
DECLARE FUNCTION CS_Fill(a AS STRING, Lenght AS LONG) AS STRING
DECLARE FUNCTION CS_InWild(BYVAL Wild AS STRING, BYVAL TEXT AS STRING, _
                           BYVAL Optionen AS LONG, BYVAL RegEx AS LONG) AS LONG
DECLARE FUNCTION CS_NextBrett(BrettPos AS LONG, KritPos AS LONG, TransBrett AS STRING, _
                              LastPos AS LONG, LastBrett AS STRING, FilterCfg()AS STRING, _
                              FilterDatei AS LONG) AS STRING
DECLARE FUNCTION CS_NextKrit(KritPos AS LONG, BrettPos AS LONG, LastKritPos AS LONG, _
                             LastKrit AS STRING, LastBrettPos AS LONG, LastPos AS LONG, _
                             LastBrett AS STRING, FilterCFG() AS STRING, _
                     FilterDatei AS LONG) AS STRING
DECLARE FUNCTION CS_Options(a AS STRING, ExtraHeader AS STRING) AS LONG
DECLARE FUNCTION CS_Separator(Zeichen AS STRING) AS LONG
'
' Die eigentliche Filterroutine
' BrettPos% = Welcher Bretteintrag wurde als letztes gefiltert
' KritPos% = Welches Kriterium im Brett wurde als letztes gefiltert
' Beides auf 0 setzen, um die Filterdatei komplett von vorne zu filtern, die
' alten Werte beibehalten, um die Filterdatei weiter zu durchsuchen.
'
' Filter verwendet die folgenden ZCONNECT-Headerzeilen:
' EDA fr Days@
' BEZ fr Thread@
' BEZ fr ISREPLY
' EMP fr XHeader-Suche
' MID fr XHeader-Suche
' BEZ fr XHeader-Suche
' LEN fr XHeader-Suche
'
DECLARE SUB CS_Filter(Mailto AS STRING, MailFrom AS STRING, Subject AS STRING, _
            References AS STRING, Zeile AS STRING, MsgId AS STRING, CSHeader() AS STRING, _
            Kriterien() AS STRING, ZielBrett AS STRING, LastBrett AS STRING, _
            FilterCfg() AS STRING, CS_Pointer AS LONG)

GLOBAL CS_ThreadBase%
GLOBAL CSLF           AS LONG
GLOBAL FilterCfg$()
GLOBAL CSBetreff$         'Standard-Filterbrett, wenn das SUB Filter als ZielBrett$ nix
                          'zurckgibt, wird in Betreff$ gefiltert.

' CS_ThreadBase% = Dateinummer der Thread-Datenbank
' FilterDatei% = Dateinummer der Filterdatei
' CSLF% = Einiges an Optionen
'         brig nur noch: CSLF% AND 32 = Filterdatei von HDD lesen
' CSLF$() = zweidimensionales Stringarray, enthlt Filterdatei
' Header$() - Sonstige Headerzeilen, eindimensionales Stringarray

FUNCTION CS_CheckThread(No AS LONG, MsgId AS STRING, References AS STRING) AS LONG

        LOCAL Buffer         AS STRING
        LOCAL ID             AS STRING
        LOCAL Bezug          AS STRING
        LOCAL TPos           AS LONG
        LOCAL LastBez        AS LONG
        LOCAL Dummy          AS LONG
        LOCAL Jau            AS LONG
        LOCAL i              AS LONG

        ' Probleme mit der Datenbank...?
        IF CS_ThreadBase% > 0 THEN
            ' Puffer Initialisieren
            Buffer$ = SPACE$(8000)
            ' Dateiposition berechnen
            TPos& = 1 + CLNG(No& - 1) * 8000
            ' ID ins richtige Format bringen
            ID$ = CHR$(254) + CS_Fill$(MsgId$, 79)
            ' Eintrag lesen
            GET #CS_ThreadBase, TPos&, Buffer$

            ' berprfen, ob Bezug vorhanden...
            LastBez& = -1
            Dummy& = INSTR(References$, CHR$(13) + CHR$(10))

            DO
                ' Bei mehreren Bezgen aktuellen herausfinden...
                IF Dummy& THEN
                    Bezug$ = MID$(References$, LastBez& + 2, Dummy& - LastBez& - 1)
                    LastBez& = Dummy&
                ELSE
                    Bezug$ = MID$(References$, LastBez& + 2)
                END IF

                ' berprfen, ob Bezug besteht...
                Bezug$ = CHR$(254) + CS_Fill$(Bezug$, 79)
                Jau& = INSTR(Buffer$, Bezug$)
                IF Jau& THEN
                    ' Es besteht Bezug...
                    CS_CheckThread& = 1
                    IF INSTR(Buffer$, ID$) = 0 THEN
                        ' Aktuelle ID hinzufgen...
                        Buffer$ = RTRIM$(Buffer$)
                        i& = (INT(LEN(Buffer$) / 80) + 1) * 80
                        IF i& <> LEN(Buffer$) THEN
                            Buffer$ = CS_Fill$(Buffer$, i&)
                        END IF
                        Buffer$ = Buffer$ + ID$
                        ' Puffer auf 8000 Bytes bringen...
                        IF LEN(Buffer$) < 8000 THEN
                            Buffer$ = CS_Fill$(Buffer$, 8000)
                        ELSEIF LEN(Buffer$) > 8000 THEN
                            Buffer$ = RIGHT$(Buffer$, 8000)
                        END IF
                    END IF
                END IF
                IF LastBez& > 0 THEN
                    Dummy& = INSTR(LastBez& + 1, References$, CHR$(13) + CHR$(10))
                END IF
            LOOP UNTIL Dummy& = 0
            ' Aktuellen Puffer wegschreiben.
            PUT #CS_ThreadBase, TPos&, Buffer$
        END IF
END FUNCTION

FUNCTION CS_Count(S AS STRING, Zeichen AS STRING) AS LONG

        LOCAL Anzahl         AS LONG
        LOCAL Position       AS LONG

        Anzahl& = 0
        Position& = INSTR(S$, Zeichen$)
        DO WHILE Position&
            Anzahl& = Anzahl& + 1
            Position& = INSTR(Position& + 1, S$, Zeichen$)
        LOOP
        CS_Count& = Anzahl&

END FUNCTION

FUNCTION CS_DateToJulian(Datum AS STRING) AS LONG

        LOCAL Tag            AS LONG
        LOCAL Monat          AS LONG
        LOCAL Jahr           AS LONG
        LOCAL Erg1           AS LONG
        LOCAL Erg2           AS LONG
        LOCAL Erg3           AS LONG

        'Englisches Datum eingeben!
        Monat& = VAL(MID$(Datum$, 1, 2))
        Tag& = VAL(MID$(Datum$, 4, 2))
        Jahr& = VAL(MID$(Datum$, 7))
        IF Monat& > 2 THEN
            Monat& = Monat& - 3
        ELSE
            Monat& = Monat& + 9
            Jahr& = Jahr& - 1
        END IF
        Erg1& = 146097 * (Jahr& \ 100) \ 4
        Erg2& = 1461& * (Jahr& MOD 100) \ 4
        Erg3& = (153 * Monat& + 2) \ 5 + Tag& + 1721119
        CS_DateToJulian& = Erg1& + Erg2& + Erg3&

END FUNCTION

FUNCTION CS_Fill(Zkette AS STRING, Length AS LONG) AS STRING

        LOCAL b              AS STRING

        IF Length& - LEN(zkette$) > 0 THEN
            b$ = zkette$ + SPACE$(length& - LEN(zkette$))
        ELSEIF LEN(zkette$) > length& THEN
            b$ = LEFT$(zkette$, length&)
        ELSE
            b$ = zkette$
        END IF
        CS_Fill$ = b$

END FUNCTION


SUB CS_Filter(Mailto AS STRING, MailFrom AS STRING, Subject AS STRING, References AS STRING, _
              Zeile AS STRING, MsgId AS STRING, CSHeader() AS STRING, Kriterien() AS STRING, _
              ZielBrett AS STRING, LastBrett AS STRING, FilterCfg() AS STRING, CS_Pointer AS LONG)

        LOCAL CSI              AS CS_DATA PTR ' Pointer auf die Datenstruktur des Threads setzen
        LOCAL UnChangedMSGText AS LONG
        LOCAL j                AS LONG
        LOCAL iDum             AS LONG
        LOCAL DumAlt           AS LONG
        LOCAL Alle             AS LONG
        LOCAL k                AS LONG
        LOCAL LoopIt           AS LONG
        LOCAL CommandFlag      AS LONG
        LOCAL Times            AS LONG
        LOCAL Anzahl           AS LONG
        LOCAL Anfang           AS LONG
        LOCAL Ende             AS LONG
        LOCAL HeadLen          AS LONG
        LOCAL ThreadNo         AS LONG
        LOCAL Days             AS LONG
        LOCAL Bytes            AS LONG
        LOCAL RegEx            AS LONG
        LOCAL Brett            AS STRING
        LOCAL TMailTo          AS STRING
        LOCAL Kriterien        AS STRING
        LOCAL Kriterium        AS STRING
        LOCAL KritGROSS        AS STRING
        LOCAL Wort             AS STRING
        LOCAL DieOptionen      AS STRING
        LOCAL CompString       AS STRING
        LOCAL Wild             AS STRING
        LOCAL XHeader          AS STRING
        LOCAL ExtraHeader      AS STRING
        LOCAL sDum             AS STRING
        LOCAL LastKritPos      AS LONG
        LOCAL LastKrit         AS STRING
        LOCAL LastBrettPos     AS LONG

        CSI = CS_Pointer                      ' Adresse umsetzen
        @CSI.ReturnFlag& = 0
        'Quote% = 0
        @CSI.Optionen&  = 0
        UnChangedMSGText& = 1
        DO
            Brett$ = CS_NextBrett$(@CSI.BrettPos&, @CSI.KritPos&, "", @CSI.LastPos&, LastBrett$, FilterCfg$(), @CSI.FilterDatei&)
            IF LEN(Brett$) = 0 THEN EXIT DO
            IF @CSI.KritPos > 1 THEN
                j& = 1
            ELSE
                j& = 0: iDum& = 1: Alle& = 0
                DO
                    TMailTo$ = LTRIM$(MID$(Brett$, iDum&))
                    DumAlt& = iDum&
                    iDum& = INSTR(iDum& + 1, Brett$, " ")
                    IF iDum& THEN
                         TMailTo$ = RTRIM$(LEFT$(TMailTo$, iDum& - DumAlt&))
                    END IF
                    IF TMailTo$ = "ALLE" THEN
                        Alle& = 1
                    ELSE
                        j& = CS_InWild&(UCASE$(TMailTo$), UCASE$(MailTo$), 2, %False)
                        IF j& THEN
                            EXIT DO
                        END IF
                    END IF
                LOOP WHILE iDum&
                IF Alle& THEN
                    IF j& = 1 THEN
                        j& = 0
                    ELSE
                        j& = 1
                    END IF
                END IF
            END IF
            TMailTo$ = "": DumAlt& = 0
            IF j& = 1 THEN
                'IF ZNETZ% AND 2 THEN PRINT #7, "  Passender Bretteintrag: " + Brett$
                'IF UnChangedMSGText% = 1 AND MSGText$ <> "Oflw" THEN
                ' evtl. Tearline und Origin entfernen
                'IF (ZNetz% AND 1) = 0 THEN
                '   a% = INSTR(MSGText$, CHR$(13) + "---")
                '   DO WHILE a%
                '      IF MID$(MSGText$, a% + 4, 1) <> "-" THEN
                '         MSGText$ = LEFT$(MSGText$, a%)
                '         EXIT DO
                '      ELSEIF LEN(MSGText$) >= a% + 1 THEN
                '         a% = INSTR(a% + 1, MSGText$, CHR$(13) + "---")
                '      ELSE
                '         a% = 0
                '      END IF
                '   LOOP
                '   IF a% = 0 THEN
                '      a% = INSTR(MSGText$, CHR$(10) + "---")
                '      DO WHILE a%
                '         IF MID$(MSGText$, a% + 5, 1) <> "-" THEN
                '            MSGText$ = LEFT$(MSGText$, a%)
                '            EXIT DO
                '         ELSEIF LEN(MSGText$) >= a% + 1 THEN
                '            a% = INSTR(a% + 1, MSGText$, CHR$(10) + "---")
                '         ELSE
                '            EXIT DO
                '         END IF
                '      LOOP
                '   END IF
                'END IF
                'UnChangedMSGText% = 0
                'END IF
                DO
                    @CSI.KritPos& = @CSI.KritPos& + 1
                    Kriterien$ = CS_NextKrit$(@CSI.KritPos&, @CSI.BrettPos, LastKritPos&, LastKrit$, _
                                              LastBrettPos&, @CSI.LastPos, LastBrett$, FilterCfg$(), _
                                              @CSI.FilterDatei)
                    iDum& = INSTR(Kriterien$, "")
                    IF iDum& THEN
                        ZielBrett$ = MID$(Kriterien$, iDum& + 1)
                        Kriterien$ = LEFT$(Kriterien$, iDum& - 1)
                    ELSE
                        ZielBrett$ = ""
                    END IF

                    IF LEN(Kriterien$) = 0 THEN EXIT DO

                    LoopIt& = INSTR(Kriterien$, ";")

                    IF LoopIt& THEN
                        iDum& = CS_Count&(LEFT$(Kriterien$, LoopIt& - 1), CHR$(34))
                        DO WHILE (iDum& / 2 <> INT(iDum& / 2)) AND LoopIt& <> 0
                           'Semikolon in Tddelchen
                           LoopIt& = INSTR(LoopIt& + 1, Kriterien$, ";")
                           IF LoopIt& THEN
                               iDum& = CS_Count&(LEFT$(Kriterien$, LoopIt& - 1), CHR$(34))
                           END IF
                       LOOP
                   IF LoopIt& THEN
                       Kriterium$ = LEFT$(Kriterien$, LoopIt& - 1)
                       iDum& = INSTR(Kriterien$, "")
                       IF iDum& THEN
                           DieOptionen$ = MID$(Kriterien$, iDum&, INSTR(iDum&, Kriterien$, " ") - iDum&)
                           iDum& = INSTR(DieOptionen$, ";")
                           IF iDum& THEN
                              DieOptionen$ = LEFT$(DieOptionen$, iDum& - 1)
                           END IF
                           IF INSTR(Kriterium$, "") = 0 THEN
                               Kriterium$ = Kriterium$ + DieOptionen$
                           END IF
                       END IF
                   ELSE
                       Kriterium$ = Kriterien$
                   END IF
             ELSE
                 Kriterium$ = Kriterien$
             END IF
             DO
                @CSI.ReturnFlag& = 0
                KritGROSS$ = UCASE$(Kriterium$)
                CompString$ = ""
                @CSI.Optionen& = CS_Options&(KritGROSS$, ExtraHeader$)
                CommandFlag& = 0 'Feststellen, ob Kommando mit @ zutraf
                iDum& = INSTR(KritGROSS$, "@")
                IF iDum& THEN
                   'iDum% = INSTR(KritGROSS$, "QUOTE@")
                   'IF iDum% THEN
                   '   idum% = INSTR(KritGROSS$, "FULLQUOTE@")
                   '   CommandFlag% = 1
                   '   Quote% = VAL(MID$(Kriterium$, iDum% + 6))
                   '   iDum% = INSTR(iDum%, Kriterium$, CHR$(34))
                   '   Quote$ = MID$(Kriterium$, iDum% - 1, 1)
                   '   IF idum% = 0 THEN
                   '      ' Prozentanteil berechnen
                   '      a% = OverQuote%(MSGText$, Quote$, 0)
                   '   ELSE
                   '      ' Zeilen Quote am Ende zhlen
                   '      a% = OverQuote%(MSGText$, Quote$, 1)
                   '   END IF
                   '   IF ((a% >= Quote%) AND ((Optionen& AND 8192) = 0)) OR ((a% < Quote%) AND ((Optionen& AND 8192) = 8192)) THEN
                   '      ReturnFlag% = 3
                   '      Quote% = a%
                   '   END IF
                   'ELSE
                      iDum& = INSTR(KritGROSS$, "BYTES@")
                      IF iDum& THEN
                          CommandFlag& = 1
                          IF Bytes& >= VAL(MID$(Kriterium$, iDum& + 6)) THEN @CSI.ReturnFlag = 1
                          GOSUB CheckNOT
                      ELSE
                          iDum& = INSTR(KritGROSS$, "DAYS@")
                          IF iDum& THEN
                              CommandFlag& = 1
                              'FOR k& = 1 TO UBOUND(CSHeader$)
                              '    IF UCASE$(LEFT$(CSHeader$(k&), 4)) = "EDA:" THEN
                              '        sDum$ = LTRIM$(MID$(CSHeader$(k&), 5, 8))
                              '        sDum$ = MID$(sDum$, 5, 2) + "." + RIGHT$(sDum$, 2) + "." + LEFT$(sDum$, 4)
                              '        Days& = ABS(CS_DateToJulian&(DATE$) - CS_DateToJulian&(sDum$))
                              '        EXIT FOR
                              '    END IF
                              'NEXT k&
                              IF Days& >= VAL(MID$(Kriterium$, iDum& + 5)) THEN @CSI.ReturnFlag& = 1
                             GOSUB CheckNOT
                          ELSE
                              'iDum% = INSTR(KritGROSS$, "NEARBY@")
                              'IF iDum% THEN
                              '   CommandFlag% = 1
                              '   Kriterium$ = Kriterium$ + " "
                              '   AnfangWort1% = INSTR(iDum%, Kriterium$, " ") + 1
                              '   Entfernung% = VAL(MID$(Kriterium$, iDum% + 7, AnfangWort1% - iDum% - 7))
                              '   AnfangWort2% = INSTR(AnfangWort1%, Kriterium$, " ") + 1
                              '   Wort1$ = MID$(Kriterium$, AnfangWort1%, AnfangWort2% - AnfangWort1% - 1)
                              '   Wort2$ = MID$(Kriterium$, AnfangWort2%, INSTR(AnfangWort2%, Kriterium$, CHR$(34)) - AnfangWort2%)
                              '   AnfangWort1% = 0: AnfangWort2% = 0: iDum% = 0: Dummy1% = 0
                              '   DO
                              '      IF Optionen& AND 2 THEN Dummy1% = INSTR(Dummy1% + 1, MSGText$, Wort1$) ELSE Dummy1% = INSTR(Dummy1% + 1, UCASE$(MSGText$), UCASE$(Wort1$))
                              '      IF Dummy1% THEN
                              '         Dummy2% = 0
                              '         DO
                              '            IF Optionen& AND 2 THEN Dummy2% = INSTR(Dummy2% + 1, MSGText$, Wort2$) ELSE Dummy2% = INSTR(Dummy2% + 1, UCASE$(MSGText$), UCASE$(Wort2$))
                              '            IF Dummy2% THEN
                              '               IF ABS(Dummy1% - Dummy2%) <= Entfernung% THEN ReturnFlag% = 1
                              '            END IF
                              '         LOOP UNTIL ReturnFlag% = 1 OR Dummy2% = 0
                              '      END IF
                              '   LOOP UNTIL ReturnFlag% = 1 OR Dummy1% = 0
                              '   Wort1$ = "": Wort2$ = "": Entfernung% = 0
                              '   GOSUB CheckNOT
                              'ELSE
                              iDum& = INSTR(KritGROSS$, "THREAD@")
                              IF iDum& THEN
                                  CommandFlag& = 1
                                  ThreadNo& = VAL(MID$(KritGROSS$, iDum& + 7))
                                  IF ThreadNo& > 0 AND ThreadNo& < 51 THEN
                                     @CSI.ReturnFlag = CS_CheckThread&(ThreadNo&, MsgId$, References$)
                                  END IF
                                  ThreadNo& = 0
                                  GOSUB CheckNOT
                              ELSE
                                  iDum& = INSTR(KritGROSS$, "TIMES@")
                                  IF iDum& THEN
                                     CommandFlag& = 1
                                     Times& = VAL(MID$(KritGROSS$, iDum& + 6))
                                     iDum& = INSTR(iDum& + 6, KritGROSS$, ",")
                                     IF iDum& THEN
                                        Wort$ = MID$(KritGROSS$, iDum&)
                                        Anzahl& = 0
                                        IF (NOT @CSI.Optionen& AND 2) THEN
                                           Wort$ = UCASE$(LTRIM$(RTRIM$(Wort$)))
                                           IF (@CSI.Optionen& AND 256) THEN Anzahl& = Anzahl& + CS_Count&(UCASE$(Subject$), Wort$)
                                           IF (@CSI.Optionen& AND 128) THEN Anzahl& = Anzahl& + CS_Count&(UCASE$(MailFrom$), Wort$)
                                           'IF Optionen& AND 1 THEN Anzahl% = Anzahl% + Count%(UCASE$(MSGText$), Wort$)
                                        ELSE
                                           IF (@CSI.Optionen& AND 256) THEN Anzahl& = Anzahl& + CS_Count&(Subject$, Wort$)
                                           IF (@CSI.Optionen& AND 128) THEN Anzahl& = Anzahl& + CS_Count&(MailFrom$, Wort$)
                                           'IF Optionen& AND 1 THEN Anzahl% = Anzahl% + Count%(MSGText$, Wort$)
                                        END IF
                                        IF Times& <= Anzahl& THEN @CSI.ReturnFlag = 1
                                        Times& = 0: Wort$ = ""
                                        GOSUB CheckNOT
                                     END IF
                                  END IF
                              END IF
                             'END IF
                          END IF
                      END IF
                   'END IF
                END IF
                IF CommandFlag& = 0 THEN
                   IF INSTR(KritGROSS$, "KILLALL") THEN
                      @CSI.ReturnFlag& = 1
                      Zeile$ = "Bla NONE"
                      EXIT DO
                   'ELSEIF INSTR(KritGROSS$, "STRIPQUOTE") THEN
                   '   IF INSTR(KritGROSS$, "STRIPQUOTEALL") <> 0 THEN
                   '      CSLF% = CSLF% OR 8
                   '   ELSE
                   '      CSLF% = CSLF% OR 4
                   '   END IF
                   ELSEIF INSTR(KritGROSS$, "ISREPLY") THEN
                      IF LEN(References$) > 0 THEN @CSI.ReturnFlag& = 1
                      GOSUB CheckNOT
                   'ELSEIF INSTR(KritGROSS$, "ISMYMAIL") THEN
                   '   IF WriteMSG% = 1 THEN ReturnFlag% = 1
                   '   GOSUB CheckNOT
                   ELSE
                      IF INSTR(UCASE$(Kriterium$), "REGEXPR") = 1 THEN
                          RegEx = %True
                      ELSE
                          RegEX = %False
                      END IF
                      Anfang& = INSTR(Kriterium$, CHR$(34))
                      Ende& = INSTR(Anfang& + 1, Kriterium$, CHR$(34))
                      Wild$ = MID$(Kriterium$, Anfang& + 1, Ende& - Anfang& - 1)

                      IF (NOT @CSI.Optionen& AND 2) THEN Wild$ = UCASE$(Wild$)
                      IF (@CSI.Optionen& AND 256) THEN @CSI.ReturnFlag& = CS_InWild(Wild$, Subject$, @CSI.Optionen&, RegEx&)
                      IF @CSI.ReturnFlag& = 0 THEN
                         IF (@CSI.Optionen& AND 128) THEN
                             @CSI.ReturnFlag& = CS_InWild(Wild$, MailFrom$, @CSI.Optionen&, RegEx&)
                         END IF
                         IF @CSI.ReturnFlag& = 0 THEN
                            'IF Optionen& AND 16 THEN ReturnFlag% = InWild(Wild$, LTRIM$(MID$(TO$, 10)), Optionen&)
                            IF (@CSI.Optionen& AND 16) THEN @CSI.ReturnFlag = CS_InWild(Wild$, MailTo$, @CSI.Optionen&, RegEx&)
                            IF @CSI.ReturnFlag = 0 THEN
                               'IF Optionen& AND 1 THEN ReturnFlag% = InWild(Wild$, MSGText$, Optionen&, UnChangedMSGText%)
                               DO WHILE LEN(ExtraHeader$) AND @CSI.ReturnFlag& = 0
                                   iDum& = INSTR(ExtraHeader$, ":")
                                   IF iDum& THEN
                                       XHeader$ = LEFT$(ExtraHeader$, iDum&)
                                       ExtraHeader$ = MID$(ExtraHeader$, iDum& + 1)
                                   ELSE
                                       XHeader$ = ExtraHeader$
                                       ExtraHeader$ = ""
                                   END IF
                                   XHeader$ = UCASE$(XHeader$)
                                   SELECT CASE XHeader$
                                          ' Trennung von Envelope und To: im Header
                                          'CASE "EMP:", "TO:"
                                          '     sDum$ = MailTo$
                                          CASE "MID:", "MESSAGE-ID:"
                                               sDum$ = MsgId$
                                          CASE "BEZ:", "REFERENCES:"
                                               sDum$ = References$
                                          CASE "LEN:"
                                               sDum$ = MID$(STR$(Bytes&), 2)
                                          CASE ELSE
                                               HeadLen& = LEN(XHeader$)
                                               sDum$ = ""
                                               FOR k& = 1 TO UBOUND(CSHeader$)
                                                   IF LEN(CSHeader$(k&)) = 0 THEN EXIT FOR
                                                   IF UCASE$(LEFT$(CSHeader$(k&), HeadLen&)) = XHeader$ THEN
                                                       sDum$ = sDum$ + LTRIM$(MID$(CSHeader$(k&), INSTR(CSHeader$(k&), ":") + 1)) + CHR$(255)
                                                   END IF
                                               NEXT k&
                                   END SELECT
                                   ' alt
                                   'IF LEN(sDum$) THEN
                                   '    ReturnFlag% = CS_InWild(Wild$, sDum$, Optionen&)
                                   'END IF
                                   ' neu
                                   IF LEN(sDum$) THEN
                                       IF (RIGHT$(Wild$, 1) <> "*") AND (INSTR(sDum$, CHR$(13)) > 0) THEN
                                           @CSI.ReturnFlag& = CS_InWild(Wild$ + CHR$(13) + "*", sDum$ + CHR$(13), @CSI.Optionen&, RegEx&)
                                       ELSE
                                           @CSI.ReturnFlag& = CS_InWild(Wild$, sDum$, @CSI.Optionen&, RegEx&)
                                       END IF
                                   END IF
                               LOOP
                               HeadLen& = 0
                               iDum& = 0
                               ExtraHeader$ = ""
                               XHeader$ = ""
                               k& = 0
                            END IF
                         END IF
                      END IF
                      KritGROSS$ = "": Wild$ = ""
                      ' Invers suchen
                      IF (@CSI.Optionen& AND 8192) THEN
                         IF @CSI.ReturnFlag& = 0 THEN
                             @CSI.ReturnFlag& = 1
                         ELSE
                             @CSI.ReturnFlag& = 0
                         END IF
                      END IF
                   END IF
                END IF
                SELECT CASE LoopIt&
                       CASE 0
                            EXIT DO
                       CASE > 0
                            IF @CSI.ReturnFlag& = 0 THEN EXIT DO
                            iDum& = INSTR(LoopIt& + 1, Kriterien$, ";")
                            IF iDum& THEN
                               Kriterium$ = MID$(Kriterien$, LoopIt& + 1, iDum& - LoopIt& - 1)
                               IF INSTR(Kriterium$, "") = 0 THEN Kriterium$ = Kriterium$ + DieOptionen$
                               LoopIt& = iDum&
                            ELSE
                               Kriterium$ = MID$(Kriterien$, LoopIt& + 1)
                               LoopIt& = 0
                            END IF
                END SELECT
             LOOP
             IF @CSI.ReturnFlag& <> 0 THEN
                Zeile$ = Kriterien$ + "" + ZielBrett$
                EXIT DO
             END IF
          LOOP
          IF @CSI.ReturnFlag& <> 0 THEN EXIT DO
       END IF
       @CSI.BrettPos& = @CSI.BrettPos& + 1
    LOOP
    IF @CSI.ReturnFlag& = 0 THEN
        @CSI.BrettPos& = 1
        @CSI.KritPos& = 1
    END IF
EXIT SUB

CheckNOT:
        IF (@CSI.Optionen& AND 8192) THEN
            IF @CSI.ReturnFlag& = 0 THEN
                @CSI.ReturnFlag& = 1
            ELSE
                @CSI.ReturnFlag& = 0
            END IF
        END IF
        RETURN
END SUB

FUNCTION CS_InWild(BYVAL Wild AS STRING, BYVAL TEXT AS STRING, BYVAL Optionen AS LONG, BYVAL RegEx AS LONG) AS LONG

        LOCAL WildTemp       AS LONG
        LOCAL WildRun        AS LONG
        LOCAL Special        AS LONG
        LOCAL Sternchen      AS LONG
        LOCAL Frage          AS LONG
        LOCAL pt             AS LONG
        LOCAL pw             AS LONG
        LOCAL Dummy          AS LONG
        LOCAL W1             AS STRING
        LOCAL W              AS STRING
        LOCAL t              AS STRING

        WildTemp& = 0
        IF (NOT Optionen& AND 2) THEN Text$ = UCASE$(Text$)
        pt&      = 1
        WildRun& = 0
        Special& = 0
        IF RegEx = %True THEN
            REGEXPR Wild$ IN Text$ + CHR$(13,10) TO pt&, pw&
            'REGEXPR Wild$ IN Text$ TO pt&, pw&
            IF pw& = 0 THEN
                WildTemp& = 0
            ELSE
                WildTemp& = 1
            END IF
        ELSE
            W1$ = MID$(Wild$, 1, 1)
            FOR pw& = 1 TO LEN(Wild$)
                W$ = W1$
                W1$ = MID$(Wild$, pw& + 1, 1)
                IF W$ = "*" AND Special& = 0 THEN
                    IF W1$ <> "*" AND W1$ <> "?" THEN
                        WildRun& = 1
                    ELSE
                        Special& = 1
                    END IF
                ELSE
                    Special& = 0
                    IF WildRun& THEN
                        Sternchen& = INSTR(pw&, Wild$, "*")
                        Frage& = INSTR(pw&, Wild$, "?")
                        IF Frage& = 0 THEN
                            IF Sternchen& = 0 THEN
                                W$ = MID$(Wild$, pw&)
                                pw& = LEN(Wild$)
                            ELSE
                                W$ = MID$(Wild$, pw&, Sternchen& - pw&)
                                pw& = Sternchen& - 1
                                W1$ = MID$(Wild$, pw& + 1, 1)
                            END IF
                        ELSE
                            IF Sternchen& = 0 OR Frage& < Sternchen& THEN
                                Dummy& = Frage&
                            ELSE
                                Dummy& = Sternchen&
                            END IF
                            W$ = MID$(Wild$, pw&, Dummy& - pw&)
                            pw& = Dummy& - 1
                            W1$ = MID$(Wild$, pw& + 1, 1)
                        END IF
                        pt& = INSTR(pt&, Text$, W$)
                        WildRun& = 0
                        IF pt& = 0 THEN
                            EXIT FOR
                        END IF
                        IF (Optionen& AND 4) THEN
                            IF pw& - LEN(W$) = 1 AND pt& > 1 THEN
                                IF LEFT$(Wild$, 1) = "*" THEN
                                    IF CS_Separator&(MID$(Text$, pt& - 1, 1)) = 0 THEN
                                        EXIT FOR
                                    END IF
                                END IF
                            END IF
                            IF pw& + LEN(W$) - 1 = LEN(Wild$) THEN
                                IF RIGHT$(Wild$, 1) = "*" AND pt& + LEN(W$) <= LEN(Text$) THEN
                                    IF CS_Separator&(MID$(Text$, pt& + LEN(W$), 1)) = 0 THEN
                                        EXIT FOR
                                    END IF
                                END IF
                            END IF
                        END IF
                        IF LEN(W$) > 1 THEN
                            pt& = pt& + LEN(W$) - 1
                        END IF
                    ELSEIF W$ <> "?" THEN
                        ' Exact match
                        t$ = MID$(Text$, pt&, 1)
                        IF W$ <> t$ THEN
                           CS_InWild& = 0
                           EXIT FUNCTION
                        END IF
                    END IF
                    pt& = pt& + 1
                END IF
            NEXT pw&
            IF pt& = LEN(Text$) + 1 OR WildRun& = 1 THEN
                WildTemp& = 1
            ELSEIF pt& > 0 THEN
                IF MID$(Text$, pt&, 1) = CHR$(255) THEN
                    WildTemp& = 1
                END IF
            END IF
        END IF
        CS_InWild& = WildTemp&

END FUNCTION

FUNCTION CS_NextBrett(BrettPos AS LONG, KritPos AS LONG, TransBrett AS STRING, _
                      LastPos AS LONG, LastBrett AS STRING, FilterCfg() AS STRING, _
                      FilterDatei AS LONG) AS STRING

        LOCAL Dummy           AS STRING
        LOCAL Brett           AS STRING

        IF LEN(TransBrett$) THEN
            KritPos& = 1
            LastBrett$ = TransBrett$
            LastPos&   = BrettPos& + 1
            EXIT FUNCTION
        END IF

        IF BrettPos& = LastPos& THEN
            CS_NextBrett$ = LastBrett$
            IF BrettPos& = 1 THEN
                IF (CSLF& AND 32) = 32 AND KritPos& = 1 THEN
                    SEEK #FilterDatei&, 1
                    DO WHILE NOT EOF(FilterDatei&)
                        LINE INPUT #FilterDatei&, Dummy$
                        IF LEFT$(Dummy$, 3) = "---" THEN EXIT DO
                    LOOP
                END IF
            END IF
            EXIT FUNCTION
        END IF

        KritPos& = 1
        IF (NOT CSLF& AND 32) THEN
            IF BrettPos& > UBOUND(FilterCfg$, 1) THEN
                CS_NextBrett$ = ""
            ELSE
                LastPos&      = BrettPos&
                LastBrett$    = FilterCfg$(BrettPos&, 1)
                CS_NextBrett$ = LastBrett$
            END IF
        ELSE
            IF BrettPos& = 1 THEN
                SEEK #FilterDatei&, 1
            END IF
            Brett$ = ""
            DO WHILE NOT EOF(FilterDatei&)
                LINE INPUT #FilterDatei&, Dummy$
                IF LEFT$(Dummy$, 3) = "---" THEN
                    Brett$ = UCASE$(LTRIM$(RTRIM$(MID$(Dummy$, 4))))
                    LastPos& = BrettPos&
                    LastBrett$ = Brett$
                    EXIT DO
                END IF
            LOOP
            CS_NextBrett$ = Brett$
        END IF
END FUNCTION

FUNCTION CS_NextKrit(KritPos AS LONG, BrettPos AS LONG, LastKritPos AS LONG, _
                     LastKrit AS STRING, LastBrettPos AS LONG, LastPos AS LONG, _
                     LastBrett AS STRING, FilterCFG() AS STRING, FilterDatei AS LONG) AS STRING

        LOCAL Krit           AS STRING
        LOCAL sDum           AS STRING
        LOCAL DumStr         AS STRING
        LOCAL iDum           AS LONG

        IF KritPos& = LastKritPos& AND BrettPos& = LastBrettPos& THEN
            CS_NextKrit$ = LastKrit$
            EXIT FUNCTION
        END IF

        IF (NOT CSLF& AND 32) THEN
            IF KritPos& > UBOUND(FilterCfg$, 2) THEN
                CS_NextKrit$ = ""
            ELSE
                LastKritPos&  = KritPos&
                LastBrettPos& = BrettPos&
                LastKrit$     = FilterCfg$(BrettPos&, KritPos&)
                CS_NextKrit$  = LastKrit$
            END IF
        ELSE
            Krit$ = ""
            DO WHILE NOT EOF(FilterDatei&)
                LINE INPUT #FilterDatei&, sDum$
                iDum& = INSTR(sDum$, "")
                DumStr$ = LEFT$(sDum$, 3)
                ' Das Weitergeben von Standardzeilen unterbinden
                IF iDum& > 0 THEN
                    IF DumStr$ <> "" THEN
                        sDum$ = LEFT$(sDum$, iDum& - 1)
                    ELSE
                        sDum$ = "'"
                    END IF
                ELSEIF DumStr$ = "" THEN
                    sDum$ = "'"
                ELSEIF DumStr$ = "+++" THEN
                    sDum$ = "'"
                END IF
                IF DumStr$ = "---" THEN
                    sDum$ = CS_NextBrett$(BrettPos&, KritPos&, UCASE$(LTRIM$(RTRIM$(MID$(sDum$, 4)))), _
                               LastPos&, LastBrett$, FilterCfg$(), FilterDatei&)
                    EXIT DO
                END IF
                IF LEFT$(sDum$, 1) <> "'" THEN
                    Krit$         = RTRIM$(sDum$) + " "
                    LastKritPos&  = KritPos&
                    LastBrettPos& = BrettPos&
                    LastKrit$     = Krit$
                    EXIT DO
                END IF
            LOOP
            CS_NextKrit$ = Krit$
        END IF
END FUNCTION

FUNCTION CS_Options(a AS STRING, ExtraHeader AS STRING) AS LONG

        LOCAL Action         AS LONG
        LOCAL iDum           AS LONG
        LOCAL intDum         AS LONG
        LOCAL b              AS STRING
        LOCAL d              AS STRING
        LOCAL OPT            AS LONG      ' Optionen (Flagfeld

        iDum& = INSTR(a$, "")
        IF iDum& = 0 THEN
            CS_Options& = 256 + 4096
            EXIT FUNCTION
        END IF
        a$ = a$ + " "
        b$ = MID$(a$, iDum& + 1, INSTR(iDum&, a$, " ") - 1 - iDum&)
        ExtraHeader$ = ""
        iDum& = INSTR(b$, CHR$(34))
        DO WHILE iDum&
            intDum& = INSTR(iDum& + 1, b$, CHR$(34))
            IF intDum& THEN
                ExtraHeader$ = ExtraHeader$ + MID$(b$, iDum& + 1, intDum& - iDum& - 1)
                b$ = LEFT$(b$, iDum& - 1) + MID$(b$, intDum& + 1)
            ELSE
                ExtraHeader$ = ExtraHeader$ + MID$(b$, iDum& + 1)
                b$ = LEFT$(b$, iDum& - 1)
            END IF
            iDum& = INSTR(b$, CHR$(34))
        LOOP
        iDum& = 1: intDum& = LEN(b$) + 1
        DO WHILE intDum& > iDum&
            d$ = MID$(b$, iDum&, 1)
            SELECT CASE d$
                  CASE "V"    'im Volltext suchen
                      Opt& = Opt& + 1
                  CASE "C"    'Casesensitiv
                      Opt& = Opt& + 2
                  CASE "G"    'ganzes Wort
                      Opt& = Opt& + 4
                  CASE "Y"    'Analyse
                      Opt& = Opt& + 8
                  CASE "B"    'im Brettempfnger suchen
                      Opt& = Opt& + 16
                  CASE "E"    'externes Programm
                      Opt& = Opt& + 32
                      Action& = 1
                  CASE "I"    'ISO -> IBM Konvertierung
                      Opt& = Opt& + 64
                  CASE "N"    'im Absender suchen
                      Opt& = Opt& + 128
                  CASE "S"    'im Subject (Betreff) suchen
                      Opt& = Opt& + 256
                  CASE "R"    'Nachricht beantworten
                      Opt& = Opt& + 512
                  CASE "K"    'Nachricht kopieren
                      Opt& = Opt& + 1024
                      Action& = 1
                  CASE "L"    'Nachricht in Liste aufnehmen
                      Opt& = Opt& + 2048
                  CASE "M"    'Nachricht verschieben
                      Opt& = Opt& + 4096
                      Action& = 1
                  CASE "X"    'Nach dem Gegenteil suchen
                      Opt& = Opt& + 8192
                  CASE "Q"    'Suche abbrechen, zur nchsten Nachricht
                      Opt& = Opt& + 16384
                  CASE "H"    'Nachricht auf halten setzen
                      Opt& = Opt& + 32768
                      Action& = 1
                  CASE "D"    'Nachricht auf lschen setzen
                      Opt& = Opt& + 65536
                      Action& = 1
                  CASE "P"    'Nachricht auf gelesen setzen
                      Opt& = Opt& + 131072
                      Action& = 1
                  CASE "F"    'Nachricht auf farbig hervorheben
                      Opt& = Opt& + 262144
                      Action& = 1
                  CASE "+"    'Neue Headerzeile einfgen
                      Opt& = Opt& + 524288
                      Action& = 1
                  CASE "-"    'Headerzeile lschen
                     Opt& = Opt& + 1048576
                     Action& = 1
            END SELECT
            iDum& = iDum& + 1
        LOOP
        IF (Opt& AND 1) <> 1 AND (Opt& AND 16) <> 16 AND (Opt& AND 128) <> 128 AND _
           (Opt& AND 256) <> 256 AND LEN(ExtraHeader$) = 0 THEN Opt& = Opt& + 256
        IF Action& = 0 THEN Opt& = Opt& + 4096
        CS_Options& = Opt&

END FUNCTION

FUNCTION CS_Init (BYVAL FilterFile AS STRING, FilterCfg() AS STRING) AS LONG

        LOCAL CS_Copyright   AS STRING    ' Copyright String fr CrossSecretary
        LOCAL BET            AS STRING
        LOCAL a              AS LONG
        LOCAL b              AS LONG
        LOCAL c              AS LONG      ' aktuelle Zeile der Filterkonfiguration
        LOCAL csMax          AS LONG
        LOCAL Anz            AS LONG
        LOCAL iDum           AS LONG
        LOCAL FilterDatei    AS LONG
        LOCAL Dummy          AS STRING

        FUNCTION = %True
        ON ERROR GOTO CS_Init_Error

        CS_Copyright = ">> CrossSecretary Plugin for UKAW, CS (c) by Christian von Busse, PowerBASIC/Win32 and Multithreaded Version (c) by Thomas Gohel <<"

        IF LEN(DIR$(FilterFile$))> 0 THEN
            IF (CSLF& AND 32) = 0 THEN
                a& = 0
                CsMax& = 0
                Anz& = 0

                WaitForSingleObject Mutex_Io, %INFINITE
                iDum& = FREEFILE
                OPEN FilterFile$ FOR INPUT LOCK WRITE AS #iDum&
                Releasemutex Mutex_Io

                DO WHILE NOT EOF(iDum&)
                    LINE INPUT #iDum&, BET$
                    Dummy$ = LEFT$(BET$, 3)
                    IF Dummy$ = "---" THEN
                        Anz& = Anz& + 1
                        IF a& > CsMax& THEN CsMax& = a&
                        a& = 0
                    ELSEIF LEFT$(BET$, 1) <> "'" AND Dummy$ <> "" AND Dummy$ <> "" THEN
                        a& = a& + 1
                        IF a& > CsMax& THEN CsMax& = a&
                    END IF
                LOOP
                SEEK #iDum&, 1
                IF Anz& = 0 THEN
                    'LogWrite FilterFile$ + " ist keine gltige Filter-Datei", -1, %LogState_OtherError
                    CLOSE #iDum&
                    ' Hier muss noch irgendetwas passieren
                    FilterFile$ = "FEHLER!!!"
                    EXIT FUNCTION
                END IF
                IF Anz& * CsMax& > 5000 THEN
                    CLOSE #iDum&
                    CSLF& = CSLF& OR 32
                    GOSUB PrepareFilter
                ELSE
                    REDIM FilterCfg$(1 TO Anz&, 1 TO CsMax& + 1)
                    a& = 0
                    b& = 0
                    c& = 1
                    DO WHILE NOT EOF(iDum&)
                        LINE INPUT #iDum&, BET$
                        Anz& = INSTR(BET$, "")
                        IF Anz& <> 0 THEN
                            IF LEFT$(BET$, 3) <> "" AND INSTR(Anz&, BET$, CHR$(254)) = 0 THEN
                                BET$ = LEFT$(BET$, Anz& - 1)
                            END IF
                        END IF
                        Dummy$ = LTRIM$(RTRIM$(BET$))
                        IF LEFT$(BET$, 3) = "---" THEN
                            a& = a& + 1
                            FilterCfg$(a&, 1) = UCASE$(LTRIM$(RTRIM$(MID$(BET$, 4))))
                            b& = 2
                        ELSEIF LEFT$(BET$, 3) = "+++" THEN
                            CSBetreff$ = MID$(BET$, 4)
                            IF INSTR(CSBetreff$, "") <> 0 THEN
                                CSBetreff$ = LEFT$(CSBetreff$, INSTR(CSBetreff$, "") - 1) + MID$(CSBetreff$, INSTR(CSBetreff$, "") + 1)
                            END IF
                            IF LEFT$(CSBetreff$, 1) = "/" THEN
                                CSBetreff$ = MID$(CSBetreff$, 2)
                            END IF
                            CSBetreff$ = RTRIM$("/" + CSBetreff$)
                        ELSEIF a& > 0 AND LEN(Dummy$) > 0 AND LEFT$(Dummy$, 3) <> "" AND LEFT$(Dummy$, 3) <> "" AND LEFT$(Dummy$, 1) <> "'" THEN
                            IF INSTR(BET$, "") = 0 THEN
                                'Logwrite "incorrect CS-Syntax at line" + STR$(c&) + ": " + TRIM$(BET$), -1, %LogState_OtherError
                            ELSE
                                FilterCfg$(a&, b&) = LTRIM$(RTRIM$(BET$)) + " "
                                b& = b& + 1
                            END IF
                        END IF
                        INCR c&
                    LOOP
                    CLOSE #iDum&
                END IF
            ELSE
                GOSUB PrepareFilter
            END IF
            IF LEN(CSBetreff$) = 0 THEN CSBetreff$ = "/NONE"
        ELSE
            FilterFile$ = "FEHLER!!!"
            FUNCTION = %False
            EXIT FUNCTION
        END IF
        EXIT FUNCTION

PrepareFilter:
        WaitForSingleObject Mutex_Io, %INFINITE
        FilterDatei& = FREEFILE
        OPEN FilterFile$ FOR INPUT LOCK WRITE AS #FilterDatei&
        Releasemutex Mutex_Io

        DO WHILE NOT EOF(FilterDatei&)
            LINE INPUT #FilterDatei&, BET$
            IF LEFT$(BET$, 3) = "+++" THEN
                CSBetreff$ = MID$(BET$, 4)
                IF INSTR(CSBetreff$, "") <> 0 THEN
                    CSBetreff$ = LEFT$(CSBetreff$, INSTR(CSBetreff$, "") - 1) + MID$(CSBetreff$, INSTR(CSBetreff$, "") + 1)
                END IF
                IF LEFT$(CSBetreff$, 1) = "/" THEN
                    CSBetreff$ = MID$(CSBetreff$, 2)
                END IF
                CSBetreff$ = RTRIM$("/" + CSBetreff$)
                EXIT DO
            END IF
        LOOP
        SEEK #FilterDatei&, 1
        RETURN

CS_Init_Error:
        FUNCTION = %False
END FUNCTION

FUNCTION CS_Separator(Zeichen AS STRING) AS LONG

        LOCAL iDum          AS LONG

        IF LEN(Zeichen$) > 0 THEN
            iDum& = ASC(Zeichen$)
            IF iDum& < 65 THEN
                IF iDum& < 48 OR iDum& > 57 THEN
                    CS_Separator& = 1
                END IF
            END IF
        END IF

END FUNCTION
