'****************************************************************************
'
' PBNEWS Paket : GLOBAL.INC (Common PBNEWS Routines)
' Version      : 0.13g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
' Last Updates : see directly in the sources
'
' based on UKAW/UKAD technology
'
'****************************************************************************


'-------------------------------------------------------------------------------------------
' interne Strukturen deklarieren
'-------------------------------------------------------------------------------------------

TYPE MID_Struc
        Aktiv        AS BYTE         ' Datensatz aktiv/gelscht
        Zustand      AS BYTE         '
        BoxLen       AS BYTE         ' TP Stringlnge fr Box
        Box          AS STRING * 8   ' Server
        MsgIdLen     AS BYTE         ' TP Stringlnge fr MsgId
        MsgID        AS STRING * 255 ' <Message@Id>
END TYPE

'-------------------------------------------------------------------------------------------
' From-Zeile im CrossPoint-Style erzeugen
'-------------------------------------------------------------------------------------------
FUNCTION Get_XP_Adress(BYVAL a AS STRING) AS STRING

        LOCAL MailFrom     AS STRING      ' MailFrom
        LOCAL RealName     AS STRING      ' RealName (sofern vorhanden)
        LOCAL p1           AS INTEGER     '
        LOCAL p2           AS INTEGER

        ON ERROR GOTO Get_XP_AdressError

        a$ = TRIM$(a$)                    ' eventuelle Space entfernen

        p1% = INSTR(1, a$, "<")
        IF p1% > 0 THEN                                   ' alternate from: Style
            MailFrom$ = TRIM$(MID$(a$, p1% + 1, 255))     ' "Real Name"  <a@b.com>
            REPLACE ">" WITH "" IN MailFrom$
            IF p1% > 1 THEN
                RealName$ = " (" + TRIM$(MID$(a$, 1, p1% - 1)) + ")"
                REPLACE CHR$(34) WITH "" IN RealName$
            END IF
        ELSE
             MailFrom$ = PARSE$(a$, " ", 1)               ' CrossPoint Style
             p2% = INSTR(1, a$, " ")                      ' a@b.com (Real Name)
             IF p2% > 0 THEN
                 RealName$ = " (" + MID$(a$, p2% + 2)
             END IF
        END IF
        Get_XP_Adress = MailFrom$ + RealName$
        EXIT FUNCTION

Get_XP_AdressError:
        FUNCTION = a$
END FUNCTION

'-------------------------------------------------------------------------------------------
' From-Zeile im Netscape-Style erzeugen
'-------------------------------------------------------------------------------------------
FUNCTION Get_NC_Adress(BYVAL a AS STRING) AS STRING

        LOCAL MailFrom     AS STRING      ' MailFrom
        LOCAL RealName     AS STRING      ' RealName (sofern vorhanden)
        LOCAL p1           AS INTEGER     '
        LOCAL p2           AS INTEGER

        ON ERROR GOTO Get_NC_AdressError

        a$ = TRIM$(a$)                    ' eventuelle Space entfernen

        p1% = INSTR(1, a$, "<")
        IF p1% > 0 THEN                                   ' alternate from: Style
            MailFrom$ = TRIM$(MID$(a$, p1% + 1, 255))     ' "Real Name"  <a@b.com>
            REPLACE ">" WITH "" IN MailFrom$
            IF p1% > 1 THEN
                RealName$ = TRIM$(MID$(a$, 1, p1% - 1)) + " "
                REPLACE CHR$(34) WITH "" IN RealName$
            END IF
        ELSE
             MailFrom$ = PARSE$(a$, " ", 1)               ' CrossPoint Style
             p2% = INSTR(1, a$, " ")                      ' a@b.com (Real Name)
             IF p2% > 0 THEN
                 RealName$ = MID$(a$, p2% + 2) + " "
                 REPLACE ")" WITH "" IN RealName$
             END IF
        END IF
        Get_NC_Adress = RealName$ + "<" + MailFrom$ + ">"
        EXIT FUNCTION

Get_NC_AdressError:
        FUNCTION = a$
END FUNCTION



'-------------------------------------------------------------------------------------------
' TCP, die eigene IP-Adresse der Connection holen (Interessant fr das Logfile)
'-------------------------------------------------------------------------------------------
FUNCTION Get_IpAdress(BYVAL hTcp AS LONG) AS STRING

        LOCAL Sa       AS SockAddr_in     ' Winsock Datenstruktur
        LOCAL hWinSock AS LONG            ' echtes Win32 Handle
        LOCAL SaLen    AS LONG
        LOCAL Ip       AS LONG            ' IP Adresse als LONG
        LOCAL b        AS BYTE PTR        ' Temp

        ON ERROR GOTO GetIpAdressError

        IF Local_Ip = "" THEN
            hWinsock = FILEATTR(hTcp,2)   ' Winsock Socket Handle von PowerBASIC holen
            SaLen    = SIZEOF(Sa)         ' Lnge der Socket Datenstruktur

            IF GetSockName(hWinsock, Sa, SaLen) = 0 THEN
                Ip = Sa.sin_addr.s_addr   ' eigene IP Adresse fr aktuelle Verbindung holen
                b = VARPTR(ip)
                FUNCTION = FORMAT$(@b[0]) & "." & FORMAT$(@b[1]) & "." & _
                           FORMAT$(@b[2]) & "." & FORMAT$(@b[3])
            ELSE
                FUNCTION = "0.0.0.1"
            END IF
        ELSE
            FUNCTION = Local_Ip
        END IF
        EXIT FUNCTION

GetIpAdressError:
        FUNCTION = "0.0.0.0"
END FUNCTION

'-------------------------------------------------------------------------------------------
' Startzeit der Connection ber WDial.Dat holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_StartTime AS DOUBLE

        LOCAL iHandle  AS LONG            '
        LOCAL Temp     AS STRING          ' Puffer

        ON ERROR GOTO Get_StartTime_Error

        FUNCTION = TIMER

        IF LEN(DIR$(AppPath + "Wdial.Dat")) > 0 THEN
            WaitForSingleObject Mutex_Io, %INFINITE
            iHandle = FREEFILE
            OPEN AppPath + "WDial.Dat" FOR BINARY AS iHandle
            Releasemutex Mutex_Io
            GET$ iHandle, 9, Temp$
            FUNCTION = VAL(Temp$)
            CLOSE iHandle
        END IF
        EXIT FUNCTION

Get_StartTime_Error:
        FUNCTION = TIMER
END FUNCTION

'-------------------------------------------------------------------------------------------
' Date: Zeile erzeugen
'-------------------------------------------------------------------------------------------
FUNCTION Get_DateHeader() AS STRING

        LOCAL Year         AS STRING
        LOCAL Month        AS INTEGER
        LOCAL Day          AS INTEGER
        LOCAL DayName      AS STRING
        LOCAL sMonth       AS STRING
        LOCAL SystemDatum  AS SYSTEMTIME

        GetLocalTime SystemDatum

        Month% = VAL(MID$(DATE$, 1, 2))
        Day%   = VAL(MID$(DATE$, 4, 2))
        Year$  = MID$(DATE$ ,7, 4)
        FUNCTION = "Date: " + Get_DayName(SystemDatum.wDayOfWeek) + ", " + FORMAT$(Day%, "00") + _
                   " " + Get_MonthName(Month%) + " " + Year$ + " " + TIME$ + Get_Timezone$

END FUNCTION

'-------------------------------------------------------------------------------------------
' Tagessstring holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_DayName(BYVAL Day AS INTEGER) AS STRING

        ' Schade das Windows immer die deutschen Tage nutzt
        SELECT CASE Day
            CASE 0: FUNCTION = "Sun"
            CASE 1: FUNCTION = "Mon"
            CASE 2: FUNCTION = "Tue"
            CASE 3: FUNCTION = "Wed"
            CASE 4: FUNCTION = "Thu"
            CASE 5: FUNCTION = "Fri"
            CASE 6: FUNCTION = "Sat"
        END SELECT
END FUNCTION

'-------------------------------------------------------------------------------------------
' Monatsstring holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_MonthName(BYVAL Month AS INTEGER) AS STRING
        SELECT CASE Month
            CASE  1: FUNCTION = "Jan"
            CASE  2: FUNCTION = "Feb"
            CASE  3: FUNCTION = "Mar"
            CASE  4: FUNCTION = "Apr"
            CASE  5: FUNCTION = "May"
            CASE  6: FUNCTION = "Jun"
            CASE  7: FUNCTION = "Jul"
            CASE  8: FUNCTION = "Aug"
            CASE  9: FUNCTION = "Sep"
            CASE 10: FUNCTION = "Oct"
            CASE 11: FUNCTION = "Nov"
            CASE 12: FUNCTION = "Dec"
        END SELECT
END FUNCTION

'-------------------------------------------------------------------------------------------
' Zeitzone holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_Timezone() AS STRING

        LOCAL Bias          AS LONG       '
        LOCAL Zone          AS STRING     '
        LOCAL TimeZone      AS TIME_ZONE_INFORMATION

        ON ERROR RESUME NEXT

        ' Zeitzonenfeld berechnen
        SELECT CASE GetTimeZoneInformation(TimeZone)
            ' Standard bzw. Winterzeit
            CASE %TIME_ZONE_ID_STANDARD
                Bias = TimeZone.Bias
            ' Sommerzeit
            CASE %TIME_ZONE_ID_DAYLIGHT
                Bias = TimeZone.Bias + TimeZone.DaylightBias
            CASE ELSE
                Bias = 0
        END SELECT
        IF Bias < 0 THEN
            Bias = ABS(Bias)
            Zone = "+"
        ELSE
            Zone = "-"
        END IF
        Bias = (Bias \ 60) * 100 + (Bias MOD 60)
        FUNCTION = " " & Zone$ & FORMAT$(Bias, "0000")

END FUNCTION

'-------------------------------------------------------------------------------------------
' FileOpen, sauberes File ffnen in Multithreading-Umgebung
'-------------------------------------------------------------------------------------------
FUNCTION FileOpen(hFile AS LONG, BYVAL sFile AS STRING, BYVAL Thread_ID AS LONG) AS LONG

        ON ERROR RESUME NEXT

        WaitForSingleObject Mutex_Io, %INFINITE
        hFile = FREEFILE
        OPEN sFile FOR BINARY LOCK WRITE AS #hFile
        IF FILEATTR(hFile, 2) = 0 THEN
            hFile = -1
            FUNCTION = %False
            'Logwrite "Error (" + TRIM$(STR$(ERR)) + ") Opening " + sFile, Thread_Id, %LogState_OtherError
        ELSE
            FUNCTION = %True
        END IF
        Releasemutex Mutex_Io

END FUNCTION

'-------------------------------------------------------------------------------------------
' OnlineTime, Routine zum Errechnen der Onlinezeit
'-------------------------------------------------------------------------------------------
FUNCTION OnlineTime (BYVAL StartTime AS SINGLE, BYVAL CurrentTime AS SINGLE) AS STRING

        LOCAL TimeBuff     AS SINGLE
        LOCAL OnlineHours  AS LONG
        LOCAL OnlineMin    AS INTEGER
        LOCAL OnlineSec    AS INTEGER
        LOCAL a            AS STRING

        IF CurrentTime < StartTime THEN   ' Mitternachtsumbruch
             CurrentTime = CurrentTime + 86400
        END IF

        Timebuff    = CEIL(CurrentTime - StartTime) ' Aufrunden um Rundungsprobleme bei
        OnlineHours = TimeBuff \ 3600               ' bei MOD zu verhindern. ROUND wre
        Timebuff    = Timebuff MOD 3600             ' zwar korrekter, aber da CEIL immer
        OnlineMin   = Timebuff \ 60                 ' um eine Sekunde voraus ist, wird so
        OnlineSec   = Timebuff MOD 60               ' die langsame Console kompensiert.

        a$ = FORMAT$(OnlineHours, "00") + ":" + _
             FORMAT$(OnlineMin, "00") + ":" + _
             FORMAT$(OnlineSec, "00")
        OnlineTime = a$

END FUNCTION

'-------------------------------------------------------------------------------------------
' MediaPlay
'-------------------------------------------------------------------------------------------

SUB MediaPlay(Wavfile AS ASCIIZ)

        SndPlaySound WavFile, %SND_ASYNC OR %SND_NODEFAULT

END SUB
